// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;

/**
 * The world is the space that our people live in.
 * 
 * This class creates the population (with one random person infected). It also draws the graph on the world background.
 * 
 * Author: Michael Kölling
 * Version: 1.0 (March 2020)
 */
public class MyWorld extends World
{
    private static final int NUM_PEOPLE = 200;
    
    /* graph scaling: scaling for the y axis and x axis*/
    private static final double SCALE_X = 0.5;
    private static final int SCALE_Y = 4;
    
    private int maxInfected = 0;
    private double xOffset = 0;

    /**
     * Initialise the simulation: create the population with one infected person.
     */
    public MyWorld()
    {
        super(1000, 650, 1);
        getBackground().setColor( new  Color(243, 215, 170));
        getBackground().fill();
        getBackground().setColor(Color.BLACK);
        
        populate();
        getObjects(Person.class).get(0).infect();
    }

    /**
     * Create the initial population, randomly placed
     */
    private void populate()
    {
        int i = 0;
        while (i < NUM_PEOPLE) {
            addObject( new  Person(), Greenfoot.getRandomNumber(getWidth()), Greenfoot.getRandomNumber(getHeight()));
            i = i + 1;
        }
    }

    /**
     * The regular action during the sumulation run: draw the graph.
     */
    public void act()
    {
        drawGraph();
    }

    /**
     * Draw the graph of the number of infected people.
     */
    private void drawGraph()
    {
        List<Person> people = getObjects(null);
        int numInfected = 0;
        
        for (final Person person : people) {
            if (person.isInfected()) {
                numInfected = numInfected + 1;
            }
        }
        if (numInfected > maxInfected) {
            maxInfected = numInfected;
        }
        
        showText("Infected:" + numInfected, 100, 20);
        showText("Max:" + maxInfected, 250, 20);
        
        plotValue(numInfected);
    }

    /**
     * Plot a single value of the graph.
     */
    private void plotValue(int value)
    {
        int yOffset = getHeight() - value * SCALE_Y;
        
        getBackground().drawLine((int)xOffset, yOffset, (int)xOffset, yOffset - 6);
        xOffset = xOffset + SCALE_X;
    }
}
