// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;

/**
 * A person in our simulation. A person can be healthy, infected, or immune.
 * 
 * Author: Michael Kölling
 * Version: 1.0 (March 2020)
 */
public class Person extends Actor
{
    private static final int INFECTION_TIME = 500;
    
    private boolean isImmune = false;
    private int infection = 0;

    /**
     * Create a new person, initially healthy.
     */
    public Person()
    {
        turn(Greenfoot.getRandomNumber(360));
    }

    /**
     * Go about our daily life: move around, see what happens.
     */
    public void act()
    {
        move();
        if (isInfected()) {
            infectOthers();
            heal();
        }
    }

    /**
     * Move around (slightly randomly).
     */
    private void move()
    {
        move(1);
        if (isAtEdge()) {
            turn(90);
        }
        /* randomly turn a bit to make movement less uniform*/
        if (Greenfoot.getRandomNumber(100) < 5) {
            turn(Greenfoot.getRandomNumber(40) - 20);
        }
    }

    /**
     * If we are touching someone else, infect them. If not, do nothing.
     */
    private void infectOthers()
    {
        Person other = (Person)getOneIntersectingObject(Person.class);
        
        if (other != null) {
            other.infect();
        }
    }

    /**
     * Try to infect this person. If this person is not immune, they will be infected.
     */
    public void infect()
    {
        if ( ! isImmune) {
            infection = INFECTION_TIME;
            setImage("infected.png");
            isImmune = true;
            /* once infected, cannot get infected again*/
        }
    }

    /**
     * Heal over time. If infection is gone, we are now immune.
     */
    private void heal()
    {
        infection = infection - 1;
        if (infection == 0) {
            setImage("immune.png");
        }
    }

    /**
     * Return true if this person is infected, false otherwise.
     */
    public boolean isInfected()
    {
        return infection > 0;
    }
}
